//+------------------------------------------------------------------+ 
//|   _TRO_Above_Below                                               | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                         |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//---- indicator settings 
#property indicator_chart_window
#property indicator_buffers 0


//---- indicator parameters  
 

extern int win = 0;
extern int price.x.offset= 0 ;//250
extern int price.y.offset= 0 ;//-160

extern int   Chart_Period    = 0;
extern int   myBars          = 24 ;

extern color Up_color = Lime;
extern color Eq_color = Yellow;
extern color Dn_color = Red;


string tLabel01, tLabel02, tLabel03 ;



//+------------------------------------------------------------------+
color fColor( double i, double j)
{
color rColor ;

    if ( i > j ) rColor = Up_color; 
    else {
    if ( i < j )  rColor = Dn_color; 
    else rColor = Eq_color; }
return ( rColor );
}
 

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 

int init() 
  { 

  if(Chart_Period == 0) { Chart_Period = Period() ; }

tLabel01 = "AB1029" + Chart_Period + myBars + Symbol() ;
tLabel02 = "AB1030" + Chart_Period + myBars ;
tLabel03 = "AB1031" + Chart_Period + myBars ;


   return(0); 
  } 

int deinit() 
{ 

   ObjectDelete(tLabel01);
   ObjectDelete(tLabel02);
   ObjectDelete(tLabel03); 
      
}  

//+------------------------------------------------------------------+ 
//| Range                                                            | 
//+------------------------------------------------------------------+ 
int start() 
  { 
  
int limit; 

double open   = iOpen(NULL,Chart_Period,0) ;    
double close  = iClose(NULL,Chart_Period,0) ; 

double above, below, pctabove, pctbelow ; 

color aboveColor = Gray , belowColor = Gray, ClOpColor ;


above = 0 ;
below = 0 ;

   for(int i=1; i<=myBars; i++) 
   { 

double closei = iClose(NULL,Chart_Period,i) ; 
 
 
     if( closei > close ) {above = above  + 1  ; }
     if( closei < close ) {below = below  + 1  ; }
   } 


pctabove = ( above / myBars ) * 100 ;
pctbelow = ( below / myBars ) * 100 ;

string tpctabove = DoubleToStr(pctabove, 2 ) + "%" ;
string tpctbelow = DoubleToStr(pctbelow, 2 ) + "%" ;

string tPeriod = " "+TimeFrameToString( Chart_Period ) ;

ClOpColor  = fColor( close, open ) ;
 

string tabove =  DoubleToStr(above, 0 ) + "/" + myBars + " Above " + tpctabove ;
string tbelow =  DoubleToStr(below, 0 ) + "/" + myBars + " Below " + tpctbelow ;
                     
   ObjectCreate(tLabel01, OBJ_LABEL, win, 0, 0); 
   ObjectSetText(tLabel01,tabove, 15, "Arial Bold", aboveColor );
   ObjectSet(tLabel01, OBJPROP_CORNER, 0);
   ObjectSet(tLabel01, OBJPROP_XDISTANCE, 520+price.x.offset);
   ObjectSet(tLabel01, OBJPROP_YDISTANCE, 37+price.y.offset);
   
  
   
   ObjectCreate(tLabel02, OBJ_LABEL, win, 0, 0); 
   ObjectSetText(tLabel02,tbelow, 15, "Arial Bold", belowColor );
   ObjectSet(tLabel02, OBJPROP_CORNER, 0);
   ObjectSet(tLabel02, OBJPROP_XDISTANCE, 520+price.x.offset);
   ObjectSet(tLabel02, OBJPROP_YDISTANCE, 100+price.y.offset); 
                                        
   ObjectCreate(tLabel03, OBJ_LABEL, win, 0, 0);
   
   ObjectSetText(tLabel03,DoubleToStr(close, Digits ) +tPeriod , 30, "Arial Bold", ClOpColor );
   ObjectSet(tLabel03, OBJPROP_CORNER, 0);
   ObjectSet(tLabel03, OBJPROP_XDISTANCE, 520+price.x.offset); // 765
   ObjectSet(tLabel03, OBJPROP_YDISTANCE, 60+price.y.offset); 
          

   WindowRedraw();    
 
//} 

   return(0); 
} 

//+------------------------------------------------------------------+

 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
  
 